package com.sun.java.swing.plaf.windows;

import java.awt.Font;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.plaf.ComponentUI;
import javax.swing.JComponent;
import javax.swing.plaf.basic.BasicPopupMenuSeparatorUI;

public class WindowsPopupMenuSeparatorUI extends BasicPopupMenuSeparatorUI
{
    public WindowsPopupMenuSeparatorUI() {
    }
    
    public static ComponentUI createUI(JComponent component) {
        return new WindowsPopupMenuSeparatorUI();
    }
    
    @Override
    public void paint(Graphics graphics, JComponent component) {
        Dimension size = component.getSize();
        XPStyle xp = XPStyle.getXP();
        if (WindowsMenuItemUI.isVistaPainting(xp)) {
            int n2 = 1;
            Container parent = component.getParent();
            if ((parent instanceof JComponent)) {
                Object clientProperty = ((JComponent)parent).getClientProperty(WindowsPopupMenuUI.GUTTER_OFFSET_KEY);
                if ((clientProperty instanceof Integer)) {
                    n2 = (int)clientProperty - component.getX() + WindowsPopupMenuUI.getGutterWidth();
                }
            }
            XPStyle.Skin skin = xp.getSkin(component, TMSchema.Part.MP_POPUPSEPARATOR);
            int height = skin.getHeight();
            skin.paintSkin(graphics, n2, (size.height - height) / 2, size.width - n2 - 1, height, TMSchema.State.NORMAL);
        }
        else {
            int n = size.height / 2;
            graphics.setColor(component.getForeground());
            graphics.drawLine(1, n - 1, size.width - 2, n - 1);
            graphics.setColor(component.getBackground());
            graphics.drawLine(1, n, size.width - 2, n);
        }
    }
    
    @Override
    public Dimension getPreferredSize(JComponent component) {
        int height = 0;
        Font font = component.getFont();
        if (font != null) {
            height = component.getFontMetrics(font).getHeight();
        }
        return new Dimension(0, height / 2 + 2);
    }
}
